#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

pair <long long, long long> ComTwo(pair<long long, long long> sec1, pair <long long, long long> sec2){
    if (sec1 == sec2) return (sec1);

    long long a1 = sec1.first, a2 = sec2.first, d1 = sec1.second, d2 = sec2.second;

    if ((d2 == 0) && (d1 == 0)){
        if (a1 == a2) return make_pair(a1,d1);
        return make_pair(-1, 0);
    }

    if (d1 == 0){
        if ((a1 < a2) || ((a1 - a2)%d2 != 0)) return make_pair(-1, 0);
        return make_pair(a1, 0);
    }

    if (d2 == 0){
        if ((a2 < a1) || ((a2 - a1)%d1 != 0)) return make_pair(-1, 0);
        return make_pair(a2, 0);
    }

    if (a1 == a2){
        return make_pair(a1, d1 / __gcd(d1,d2) * d2);
    }

    if (abs(a1 - a2)%__gcd(d1,d2) != 0) {
        return make_pair(-1, 0);
    }

    if (a1 > a2) {
        swap(a1, a2);
        swap(d1, d2);
    }

    for (int i = 0; i<d1; i++){
        if (abs(i*d2 + a2 - a1)%d1 == 0) return make_pair(a2 + i*d2, d1/__gcd(d1,d2)*d2);
    }

    return make_pair(-1, 0);
}

int main(){
    freopen("common.in", "r", stdin);
    freopen("common.out", "w", stdout);

    int n;
    vector < pair <long long, long long> > Sec;

    scanf("%d", &n);
    Sec.resize(n);

    for (int i = 0; i<n; i++){
        scanf("%lld%lld", &Sec[i].first, &Sec[i].second);
    }

    for (int i = 1; i<n; i++){
        Sec[i] = ComTwo(Sec[i-1], Sec[i]);

        if (Sec[i].first == -1){
            printf("0");
            return 0;
        }

    }

    printf("%lld", Sec[n-1].first);

    return 0;
}
