#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

const int inf = 1000000007;

int n, m;

vector <vector <int> >dp;
vector <vector <pair<int, int> > > prevs;

pair <int,int> bfs(int i, int j){
    queue <pair <int,int> > Q;
    pair <int,int> cur;
    Q.push(make_pair(i,j));
    while(!Q.empty()){
        cur = Q.front();
        Q.pop();
        if(cur.first == 0 ||cur.first == n-1 ||cur.second == 0 || cur.second == m-1) return cur;
        if(dp[cur.first+1][cur.second] > dp[cur.first][cur.second]+1){
            dp[cur.first+1][cur.second] = dp[cur.first][cur.second]+1;
            prevs[cur.first+1][cur.second] = cur;
            Q.push(make_pair(cur.first+1,cur.second));
        }
        if(dp[cur.first-1][cur.second] > dp[cur.first][cur.second]+1){
            dp[cur.first-1][cur.second] = dp[cur.first][cur.second]+1;
            prevs[cur.first-1][cur.second] = cur;
            Q.push(make_pair(cur.first-1,cur.second));
        }
        if(dp[cur.first][cur.second+1] > dp[cur.first][cur.second]+1){
            dp[cur.first][cur.second+1] = dp[cur.first][cur.second]+1;
            prevs[cur.first][cur.second+1] = cur;
            Q.push(make_pair(cur.first,cur.second+1));
        }
        if(dp[cur.first][cur.second-1] > dp[cur.first][cur.second]+1){
            dp[cur.first][cur.second-1] = dp[cur.first][cur.second]+1;
            prevs[cur.first][cur.second-1] = cur;
            Q.push(make_pair(cur.first,cur.second-1));
        }
    }
    return make_pair(inf,inf);
}

int main(){
    freopen("labirint.in","r",stdin);
    freopen("labirint.out","w",stdout);
    int sx, sy;
    cin >> n >> m;
    string s;
    getline(cin,s);
    dp.resize(n+1, vector <int> (m+1));
    prevs.resize(n+1, vector <pair<int,int> > (m+1));
    pair <int,int> cur;
    for(int i = 0; i < n; i++){
        getline(cin,s);
        for(int j = 0; j < s.size(); j++){
            if(s[j] == '+'){
                dp[i][j] = 0;
                sx = i; sy = j;
            }
            else if(s[j] == ' ')
                dp[i][j] = inf;
            else dp[i][j] = -1;
        }
    }
    cur = bfs(sx,sy);
    if(cur.first == inf){
        cout << "-1\n";
        return 0;
    }
    cout << dp[cur.first][cur.second] << "\n";
    if(dp[cur.first][cur.second] == 0) return 0;
    pair <int,int> next;
    string res = "";
    while(dp[cur.first][cur.second] != 0){
        next = prevs[cur.first][cur.second];
        if(next.first - cur.first == 1) res += 'n';
        if(next.first - cur.first == -1) res += 's';
        if(next.second - cur.second == 1) res += 'w';
        if(next.second - cur.second == -1) res += 'e';
        cur = next;
    }
    for(int i = res.size()-1; i >= 0; i--){
        cout << res[i];
    }
    cout << "\n";
    return 0;
}
